 
#include<stdio.h>

struct node
{
 int papil;
 int reiksme;
 int spalva;
 struct node *lchild,*rchild,*parent;
} *root;

 
struct node *successor(struct node *);
struct node *predecessor(struct node *);

void kaire(struct node *);
void desine(struct node *);

void ideti(struct node *);
void sutvarkyti(struct node *);


void inorder(struct node *);

struct node *maximum(struct node *);
struct node *minimum(struct node *);
    

 
void ideti(struct node *z)
{
   struct node *x, *y;
   y = NULL;
   x = root;
   while ( x!=NULL)
   {
   	y = x;
       	 
       	if(z->reiksme<x->reiksme)
		x=x->lchild;  
	else
		x=x->rchild;  
   }

	z->parent=y;
    
   if(y==NULL)
         root=z;
   else
	{
	z->parent=y;
	if(z->reiksme<y->reiksme)
		y->lchild = z;
	else
        	y->rchild = z;
	}
       
   sutvarkyti(z);
}

  void kaire(struct node *x) 
{

	
	struct node *y = x->rchild;
	x->rchild = y->lchild;
	if (y->lchild != NULL) 
		  y->lchild->parent = x;
	
	if (y != NULL) 
		  y->parent = x->parent;
    if (x->parent) 
    {
  	   if (x == x->parent->lchild)
           x->parent->lchild = y;
       else
           x->parent->rchild = y;
     } 
     else 
     {
  	    root = y;
     }
       y->lchild = x;
      if (x != NULL) 
          x->parent = y;
}

void desine( struct node *x) 
{

	struct node *y = x->lchild;
	
	x->lchild = y->rchild;
	if (y->rchild != NULL) 
        y->rchild->parent = x; 
	
  if (y != NULL) 
  	    y->parent = x->parent;
    if (x->parent) 
    {
  	    if (x == x->parent->rchild)
            x->parent->rchild = y;
        else
            x->parent->lchild = y;
    } 
    else 
    {
  	    root = y;
    }
  
    y->rchild = x;
    if (x != NULL) 
    x->parent = y;
}
int CountNodes ( struct node *x){
if (x == NULL)
    return 0;
  else 
    return CountNodes(x->lchild) + CountNodes(x->rchild) + 1;
}


 


void sutvarkyti(struct node *x)
{      
 
          
	struct node *y,*e;

	while (x->parent!=NULL && x->parent->spalva==0)
	{    
          
		if (x->parent==x->parent->parent->lchild)
		{
			y=x->parent->parent->rchild;
          
			if (y!=NULL)
   	{
			if (y->spalva==0)
			{
				x->parent->spalva=1;
				y->spalva=1;
				x->parent->parent->spalva=0;
				x=x->parent->parent;
				
			}}
			else
			{      
				if (x==x->parent->rchild)
				{
					x=x->parent;
					kaire(x);
				}
				else
				{     
					x->parent->spalva=1;
					x->parent->parent->spalva=0;
					desine(x->parent->parent);
				}
			}  
		}
		else
		{      
	
			 y=x->parent->parent->lchild;
                        
			if (y!=NULL)
			{   
                        if (y->spalva==0)
                        {     
                                x->parent->spalva=1;
                                y->spalva=1;
                                x->parent->parent->spalva=0;
                                x=x->parent->parent;
                        }}
                        
                        else
                        {
                                if (x==x->parent->lchild)
                                {
                                        x=x->parent;
                                        desine(x);
                                         
                                }
                               
                                else
				{
					x->parent->spalva=1;
					x->parent->parent->spalva=0;
					kaire(x->parent->parent);
				}
				                         
               }           
			}
		}
	root->spalva=1;
	          
	
}

 

 
 void preorder(struct node *r)
{        printf("%d ",r->reiksme);
       	if (r->lchild != NULL)
	preorder (r->lchild);
       	if (r->rchild != NULL)
	preorder (r->rchild);
}
 
 void postorder(struct node *r )
{    
	if (r->lchild != NULL)
	postorder (r->lchild);
       	if (r->rchild != NULL)
	postorder (r->rchild);
	   	printf("%d ",r->reiksme);
} 
    
void inorder(struct node *r )
{    r->papil=CountNodes(r);
	struct node *z;
	if (r->lchild != NULL)
        inorder (r->lchild);
        	
        printf("\n%d    ", r->reiksme);
     //printf(" % d nera %d",r->reiksme,z->reiksme);
	z=successor(r);
//	if(r->reiksme==z->reiksme)
	//printf(" nera ");
	//else
	printf("Ipedinis: %d   ",z->reiksme);
	z=predecessor(r);
	printf("Pirmtakas: %d   spalva: ",z->reiksme);
        
	if (r->spalva==0) printf("R"); else printf("J");
	if (r->parent!=NULL) printf("   Tevas: %d",r->parent->reiksme);
         printf(" virsuniu skaicius: %d",r->papil);
	 
        if (r->rchild != NULL)
        inorder (r->rchild);
}


struct node *minimum(struct node *r)
{
	while(r->lchild!=NULL)
		r=r->lchild;
	return r;
}
 

struct node *maximum(struct node *r)
{
	while(r->rchild!=NULL)
		r=r->rchild;

	return r;
}

 
struct node *successor(struct node *r)
{    
	if (r->rchild!=NULL) {
	    
		return(minimum(r->rchild));}
	else	if (r->rchild==NULL) 
	return r;
	struct node *y=r->parent;
	while(y!=NULL && r==y->rchild)
	{
		r=y;
		y=y->parent;
	}
	if (y==NULL)
		return r;
	else
		return y;
}

 
struct node *predecessor(struct node *r)
{
	if (r->parent!=NULL)
		if (r->parent->rchild==r)
		return r->parent;
	if (r->lchild!=NULL)
		return maximum(r->lchild);
	return r;
}


 
main()
{
    int q[30];
	int choice,i,p=0,s;
	root=NULL;
	struct node *z;
	while (choice!=3)
	{
		 
		printf("\n\n\t\t Raudonai Juodas Medis");
		printf("\n\n\t 1. Iterpti nauja elementa i medi."); 
		printf("\n\n\t 2. Isvesti medi i ekrana.");
		printf("\n\n\t 3. Exit.");
		printf("\n\n\t Jusu pasirinkimas : ");
		scanf("%d",&choice);
		switch (choice)
		{
		case 1:
		system("cls");
			z=(struct node *)malloc(sizeof(struct node));
			 
                       	printf("\n\n\tIveskite skaiciu: ");
                      	scanf("%d",&i);
                      	q[p]=i;
                      	p++;
			            z->reiksme=i;
			            z->spalva=0; 
                       	z->rchild=NULL;  
                        z->lchild=NULL; 
	                    z->parent=NULL;
                       
                        ideti(z);  
                        break;
		
		case 2:  
		system("cls");
		int k;
		printf("Ivesti skaiciai : ");
		for(k = 0;k<p;k++){
		printf(" %d",q[k]); }
		printf("\n");
		z=minimum(root);  
   
	
	               
	printf("Minimum: %d ",z->reiksme);
	
		z=maximum(root);
  
			printf("Maximum: %d ",z->reiksme);
	        
			if (root!=NULL)
			{            	 	         	
                       	     	printf("\n\n\t Inorder tvarka : ");
                       		inorder(root);
	                       	printf("\n\n\t Preorder tvarka : ");
        	              	preorder(root);
                	       
	                       	printf("\n\n\t Postorder tvarka : ");
        	               	postorder(root);
			} 
		          

		case 3: break;
		}
	}
}
